/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package storage.impl.database;

import database.connection.ConnectionFactory;
import domain.Invoice;
import domain.InvoiceItem;
import java.math.BigDecimal;
import java.sql.Connection;
import java.sql.Date;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.logging.Level;
import java.util.logging.Logger;
import storage.StorageInvoice;

/**
 *
 * @author student1
 */
public class StorageDatabaseInvoice implements StorageInvoice{

    @Override
    public Invoice save(Invoice invoice) throws Exception {
        Connection connection=null;
        try {
            connection=ConnectionFactory.getInstance().getConnection();
            String upit="INSERT INTO Invoice (dateCreated, amount) VALUES (?,?)";
            PreparedStatement statement=connection.prepareStatement(upit, Statement.RETURN_GENERATED_KEYS);
            statement.setDate(1, new Date(invoice.getDateCreated().getTime()));
            statement.setBigDecimal(2, invoice.getAmount());
            statement.executeUpdate();
            ResultSet rs=statement.getGeneratedKeys();//da bi dobili autoinc ID
            if(rs.next()){
                Long id=rs.getLong(1);
                invoice.setId(id);
                upit="INSERT INTO InvoiceItem (invoice, itemNumber, product, price, quantity) VALUES (?,?,?,?,?)";
                statement=connection.prepareStatement(upit);
                for (InvoiceItem item : invoice.getInvoiceItems()) {
                    statement.setLong(1, invoice.getId());
                    statement.setLong(2, item.getItermNumber());
                    statement.setLong(3, item.getProduct().getId());
                    statement.setBigDecimal(4, item.getPrice());
                    statement.setLong(5, item.getQuantity());
                    statement.executeUpdate();
                }
            }
            connection.commit();
            rs.close();
            statement.close();
            return invoice;
        } catch (SQLException ex) {
            ex.printStackTrace();
            connection.rollback();
            throw new Exception("Greška prilikom čuvanja Računa u bazi podataka!\n"+ex.getMessage());
        }
    }
    
}
